/*
 * Copyright (c) 2018, General Electric
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// Generic
@import "../px-normalize-design/_generic.normalize.scss";
@import "../px-box-sizing-design/_generic.box-sizing.scss";
@import "../px-helpers-design/_generic.helpers.scss";

// Base

@import "../px-shadows-design/_objects.shadows.scss";

// Components
:host {
  width: 100%;
  height: 100%;
  pointer-events: none;
  z-index: var(--px-modal-z-index, 1200);
  -webkit-touch-callout: none;
  -webkit-user-select: none;
  -khtml-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

.modal {
  position: fixed;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  //visibility: hidden;
  background-color: transparent;
  opacity: 0;
  transition: background-color 0.3s cubic-bezier(.78,.13,.16,.87),
              visibility 0.3s cubic-bezier(.78,.13,.16,.87),
              opacity 0.3s cubic-bezier(.78,.13,.16,.87);
  z-index: var(--px-modal-z-index, 1200);

  display: flex;
  flex-direction: column;
  /* align-content: stretch; */
  justify-content: center;
  @include media-query(palm) {
    position: initial;
    width: 100%;
    height: 100%;
  }
}
:host([opened]) > .modal {
  visibility: visible;
  background-color: var(--px-modal-overlay-color, rgba(black, 0.65));
  opacity: 1;
  pointer-events: auto;
}

:host([opened]) > .modal-mask {
  visibility: visible;
  background-color: var(--px-modal-overlay-color, rgba(black, 0.00));
  opacity: 1;
  pointer-events: auto;
}
:host([fit-to-parent]) > .modal {
  position: initial;
  width: 100%;
  height: 100%;
}

.modal__box {
  position: fixed;
  top: 50%;
  left: 50%;
  flex-direction: column;
  justify-content: space-between;
  transform: translate(-50%, -50%);
  max-height: calc(100% - 2rem);
  max-width: calc(100% - 2rem);
  overflow: visible;
  overflow-y: auto;
  white-space: normal;
  word-wrap: break-word;
  background-color: var(--px-modal-background-color--container, white);
  //border-radius:0.5em;
  color: var(--px-modal-text-color--container, black);
  @include media-query(palm) {
    width: 100%;
    position: initial;
    transform: initial;
    height: 100%;
    width: 100%;
    max-height: 100%;
    max-width: 100%;
    box-shadow: none;
  }
  @include media-query(lap-and-up){
    min-width: calculateRem(400px);
  }
}

:host([fit-to-parent]) .modal__box {
  position: initial;
  transform: initial;
  height: 100%;
  width: 100%;
  max-height: 100%;
  max-width: 100%;
  overflow: auto;
  box-shadow: none;
  background-color: var(--px-modal-background-color--container, white);
  color: var(--px-modal-text-color--container, black);
}

.modal__header__text {
  display: block;
  padding: $inuit-base-spacing-unit--large;
  margin-bottom: 0.5em;
  @include media-query(palm) {
    text-align: center;
    box-shadow: 0px 2px 4px var(--px-shadow-navigation, rgba(black, 0.2));
  }
}
:host([fit-to-parent]) .modal__header__text {
  padding: $inuit-base-spacing-unit--huge;
}

.modal__body__text {
  display: block;
  padding: 0 $inuit-base-spacing-unit--large;
  @include media-query(palm) {
    padding: $inuit-base-spacing-unit--large;
  }
  max-height: calc(100vh - 10rem);
  overflow: auto;
}
:host([fit-to-parent]) .modal__body__text {
  padding: $inuit-base-spacing-unit--huge;
}

.modal__triggers {
  display: flex;
  flex-shrink: 0;
  justify-content: flex-end;
  padding: $inuit-base-spacing-unit--large;
  margin-top: 1.5rem;
  @include media-query(palm) {
    justify-content: space-between;
    box-shadow: 0px -2px 4px var(--px-shadow-navigation, rgba(black, 0.2));
    background-color: var(--px-modal-contrast-background-color, #ebeff2);
  }
}

:host([fit-to-parent]) .modal__triggers {
  box-shadow: 0px -2px 4px var(--px-shadow-navigation, rgba(black, 0.2));
  padding: $inuit-base-spacing-unit--huge;
  flex: 0 0 auto;
}

.modal__reject-trigger {
  flex-shrink: 0;
}

.modal__accept-trigger {
  flex-shrink: 0;
  margin-left: $inuit-base-spacing-unit;
}

.indicator-text {
  color: var(--lumo-body-text-color);
}

.v-loading-indicator0 {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  pointer-events: auto;
  z-index: 2147483647;
}
.v-loading-indicator {
  position: fixed; /* Occupy whole screen even if scrolled */
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  /* Eat mouse events when visible, doesn't prevent scrolling */
  pointer-events: auto;
  /* Animated with delay to prevent flashing */
  animation: fadein 0.3s ease-out 0.2s normal 1 both;
  z-index: 2147483647;
}
.v-loading-indicator:before {
  width: 76px;
  height: 76px;

  position: absolute;
  top: 50%;
  left: 50%;

  margin: -38px 0 0 -38px;

  //border-radius: 100%;
  //animation: bouncedelay 1.2s infinite 0.4s ease-in-out both;
  animation: fadein 0.3s ease-out 0.2s normal 1 both;
  content: "";
}

.v-loading-indicator.first:before {
  background-color: skyblue;
}

.v-loading-indicator.second:before {
  background-color: salmon;
}

.v-loading-indicator.third:before {
  background-color: red;
}

@keyframes bouncedelay {
  0%, 80%, 100% {
    transform: scale(0);
  } 40% {
    transform: scale(1.0);
  }
}

@keyframes fadein {
  0% {
    background: rgba(0,0,0,0);
  }
  100% {
    background: rgba(0,0,0,.5); /* Darkens the UI */
  }
}
